/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ReservacionCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.ReservacionCategoria;
import com.rjconsultores.ventaboletos.entidad.ReservacionClase;
import com.rjconsultores.ventaboletos.entidad.ReservacionCtrl;
import com.rjconsultores.ventaboletos.entidad.ReservacionMarca;
import com.rjconsultores.ventaboletos.entidad.ReservacionMercado;
import com.rjconsultores.ventaboletos.entidad.ReservacionPuntoVenta;
import com.rjconsultores.ventaboletos.service.ReservacionCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("reservacionCtrlService")
public class ReservacionCtrlServiceImpl implements ReservacionCtrlService {

    @Autowired
    private ReservacionCtrlDAO reservacionCtrlDAO;

    public List<ReservacionCtrl> obtenerTodos() {
        return reservacionCtrlDAO.obtenerTodos();
    }

    public ReservacionCtrl obtenerID(Integer id) {
        return reservacionCtrlDAO.obtenerID(id);
    }

    @Transactional
    public ReservacionCtrl suscribir(ReservacionCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return reservacionCtrlDAO.suscribir(entidad);
    }

    @Transactional
    public ReservacionCtrl actualizacion(ReservacionCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return reservacionCtrlDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(ReservacionCtrl entidad) {
        for (ReservacionCategoria reservacion : entidad.getReservacionCategoriaList()) {
            reservacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            reservacion.setFecmodif(Calendar.getInstance().getTime());
            reservacion.setActivo(Boolean.FALSE);
        }
        for (ReservacionClase reservacion : entidad.getReservacionClaseList()) {
            reservacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            reservacion.setFecmodif(Calendar.getInstance().getTime());
            reservacion.setActivo(Boolean.FALSE);
        }
        for (ReservacionMarca reservacion : entidad.getReservacionMarcaList()) {
            reservacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            reservacion.setFecmodif(Calendar.getInstance().getTime());
            reservacion.setActivo(Boolean.FALSE);
        }
        for (ReservacionMercado reservacion : entidad.getReservacionMercadoList()) {
            reservacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            reservacion.setFecmodif(Calendar.getInstance().getTime());
            reservacion.setActivo(Boolean.FALSE);
        }
        for (ReservacionPuntoVenta reservacion : entidad.getReservacionPuntoVentaList()) {
            reservacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            reservacion.setFecmodif(Calendar.getInstance().getTime());
            reservacion.setActivo(Boolean.FALSE);
        }


        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        reservacionCtrlDAO.actualizacion(entidad);
    }

    public List<ReservacionCtrl> buscar(ReservacionCtrl reservacionCtrl) {
        return reservacionCtrlDAO.buscar(reservacionCtrl);
    }

    public List<ReservacionCtrl> buscarFechaTraslapa(ReservacionCtrl reservacionCtrl) {
        return reservacionCtrlDAO.buscarFechaTraslapa(reservacionCtrl);
    }
}
